
sed=${sed:-sed}

input ()
{
  echo "$*" > tmp.in 
}

expect ()
{
  $sed -f bf.sed tmp.in | tr -d '\r' > tmp.out
  #(perl bf.pl tmp.in ; echo) > tmp.out
  echo "$*" > tmp.exp
  if ! cmp -s tmp.out tmp.exp
  then
    echo The following input
    cat tmp.in
    echo gave this output:
    cat tmp.out
    echo instead of the intended:
    cat tmp.exp
    echo ==
    exit 1
  fi
}

#
# check errors
#

input [
expect Error: mismatched brackets

input ]
expect Error: mismatched brackets

input -
expect Error: number decremented below zero

input +[+]
expect Error: number incremented past 255

input '<'
expect Error: pointer moved too far left

input '+[<]'
expect Error: pointer moved too far left

input '+[<<]'
expect Error: pointer moved too far left

input '>+[<<]'
expect Error: pointer moved too far left

#
# check individual commands using the debug point ?
#

input '+>++>+++?'
expect '01 02 ~03'

input '>+>+?[<]?>[>]?'
expect '00 01 ~01
~00 01 01
00 01 01 ~00'

input '>+>+?[<<]?+[>>]?'
expect '00 01 ~01
~00 01 01
01 01 01 00 ~00'

input '+[>>]?'
expect '01 00 ~00'

input '+>+<[>>]?'
expect '01 01 ~00'

#
# Test some one-liners
# 

input '+++++>+<[->[->++<]>[-<+>]<<]>+.'
expect '!'

input '++++++>+<[->[->++<]>[-<+>]<<]++++++++[->.+<]'
expect '@ABCDEFG'

# ASCII characters, input and output

input ',[+.[-],]! !"#$%&'\''()*+,-./0123456789:;<=>?'
expect '!"#$%&'\''()*+,-./0123456789:;<=>?@'

input ',[+.[-],]!@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_'
expect 'ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`'

input ',[+.[-],]!`abcdefghijklmnopqrstuvwxyz{|}'
expect 'abcdefghijklmnopqrstuvwxyz{|}~'

# test printing newline.

input '++++++++++>,<.>.<.!A'
expect '
A'

input '++++++++++...'
expect '

'


#

input '+++++[>+++++++++<-],[[>--.++>+<<-]>+.->[<.>-]<<,]!,'
a='++++++++++++++++++++++++++++++++++++++++++++'
b='--------------------------------------------'
expect "$a.$b"

input '>,[>,]<[.<]!abcde'
expect 'edcba'

input '>>,[>>,]<<[[-<+<]>[>[>>]<[.[-]<[[>>+<<-]<]>>]>]<<]!Sort bytes in ascending order.'
expect '    .Sabcddeeegiinnnoorrrsstty'

input '>,[>>>++++++++[<[<++>-]<+[>+<-]<-[-[-<]>]>[-<]<,>>>-]<.[-]<<]!0110100001101001'
expect 'hi'

input '>++++[>++++++<-]>-[[<+++++>>+<-]>-]<<[<]>>>>-
-.<<<-.>>>-.<.<.>---.<<+++.>>>++.<<---.[>]<<.'
expect 'brainfuck'

input '++++++++[>++++[>++>+++>+++>+<<<<-]>+>->+>>+[<]<-]>>.>
>---.+++++++..+++.>.<<-.>.+++.------.--------.>+.>++.'
expect 'Hello World!'

input '#convert input to binary
,[[>>[>]+<[-<]<-]>>+>+>+>+>+>+>+>+[->++++++[-<++++++++>]<.[-]<]<,]!
A'
expect '0100000100001010'
